package GrapherGUI;


import java.awt.*;
import javax.swing.*;


public class TextNumberInput extends JTextField {
    private double _val;
    private double _min, _max;

    public TextNumberInput(double min, double max, double start, int width) {
        super(width);
        setText(Util.formatDouble(start));
        _val = start;
    }

    public double val() {
        double x;

        try {
            x = Double.parseDouble(getText());
        } catch (NumberFormatException n) {
            setText(Util.formatDouble(_val));
            return _val;
        }

        if (!(_min == 0 && _max == 0) && (x > _max || x < _min)) {
            setText(Util.formatDouble(_val));
            return _val;
        }

        _val = x;
        return _val;
    }
}
