import java.applet.*;
import java.awt.*;

import GrapherGUI.*;


public class Weblec09Gaussoned extends Applet {   

    public void init() {     
        SliderMatrix sm = new SliderMatrix(4);
	AnimationManager am = new AnimationManager("t", 250, 0.25, sm);

	sm.add(0.0, 100.0, 0.0, 10, null, "t");
        sm.add(0.0, 1.0, 1.0, 4, "sigma.jpg", "sigma");
        sm.add(-7, -1.0, -1.0, 5, "log-K.jpg", "K");

        GUI gui = new GUI(sm, am, -5.0, 5.0, -0.1, 1.5);
                gui.setTickIncrementX(1.0);
                gui.setTickIncrementY(0.25);

        MyFunc1 f1 = new MyFunc1();

        gui.addFunction(f1);

        gui.setAxesIcons("axis_x.jpg", "axis_y.jpg");

        add(gui);
    } 
}

class MyFunc1 extends Function {
    public short type() {
        return Function.FCNTYPE_SINGLEVAL;
    }
    
    public Color color() {
	return Color.blue;
    }

    public String name() {
        return "Diffusion of a Gaussian Temperature Distribution";
    }

    public double f(double x, SliderMatrix p) {
        double t, sigma, K, auxa, auxb, auxc, auxd;

        try {
	    t = p.val("t");
            sigma = p.val("sigma");
            K = p.val("K");
        } catch (Error e) {
            return 0.0;
        }
	auxa = 2.0d*Math.pow(10.0d, K)*t*Math.pow(sigma, 2)+1.0d;
	auxb = Math.pow(x*sigma, 2);
	auxc = Math.exp(-auxb/(2.0d*auxa));
	auxd = auxc/Math.sqrt(auxa);

        return auxd;
    }

    public void farray(
            double minx,
            double maxx,
            int density,
            double[] a,
            double[] b,
            SliderMatrix p) {}
}




    
