package GrapherGUI;


import java.text.*;
import javax.swing.*;


/** Utility functions.
 */
public class Util {

    /** Format a double to show a double to 3 decimal places
     * @return string representation of the input
     */    
    static public String formatDouble(double n) {
        NumberFormat nf = new DecimalFormat("#.###");

        return nf.format(n);
    }
        
    /** Returns an ImageIcon, or null if the path was invalid. */
    public static ImageIcon createImageIcon(String path,
            String description) {
        java.net.URL imgURL = ParameterPanel.class.getResource(path);

        if (imgURL != null) {
            return new ImageIcon(imgURL, description);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }
}
