import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import javax.swing.*;

import GrapherGUI.*;


public class StandaloneFortran {
    static public void main(String[] args) {
        SliderMatrix sm = new SliderMatrix(3);
        AnimationManager am = new AnimationManager("t", 250, 0.25, sm);

        sm.add(0.0, 10.0, 0.0, 4, null, "t");
        sm.add(0.0, 5.0, 1.0, 4, null, "h");
        sm.add(0.0, 5.0, 1.0, 4, null, "sigma");

        GUI gui = new GUI(sm, am, 0.0, 5.0, -1.0, 1.0);
		gui.setTickIncrementX(0.5);
		gui.setTickIncrementY(0.25);

        Native nf = new Native();

        gui.addFunction(nf);
        gui.setAxesIcons("axis_x.jpg", "axis_y.jpg");

        JPanel p = new JPanel();

        p.add(gui);

        JFrame f = new JFrame("Grapher");

        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent we) {
                System.exit(0);
            }
        });
        f.setSize(610, 730);
        f.setLocation(300, 200);
        f.getContentPane().add(p);
        f.setVisible(true);
        f.show();
    } 
}
